      .486                      ; create 32 bit code
      .model flat, stdcall      ; 32 bit memory model
      option casemap :none      ; case sensitive


      include \masm32\include\windows.inc
      include \masm32\include\masm32.inc
      include \masm32\include\user32.inc
      include \masm32\include\kernel32.inc
      include \masm32\macros\macros.asm
      include \masm32\macros\windows.asm
      include \masm32\include\ws2_32.inc

      include \masm32\include\advapi32.inc

      includelib \masm32\lib\masm32.lib
      includelib \masm32\lib\user32.lib
      includelib \masm32\lib\kernel32.lib
      includelib \masm32\lib\ws2_32.lib

      includelib \masm32\lib\advapi32.lib





SendPacket PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
base64_encode PROTO :DWORD, :DWORD, :DWORD, :DWORD
base64_decode PROTO :DWORD, :DWORD, :DWORD
SocketInit PROTO
SocketCleanup PROTO
urlencode PROTO :DWORD, :DWORD, :DWORD
urlencodeW PROTO :DWORD, :DWORD, :DWORD
GetHttpHeader PROTO :DWORD, :DWORD, :DWORD
GetHttpBody PROTO :DWORD, :DWORD, :DWORD
GetHttpBodyEx PROTO :DWORD, :DWORD, :DWORD, :DWORD
GetCookies PROTO :DWORD, :DWORD, :DWORD
GetHTTPAnswer PROTO :DWORD
MD5 PROTO :DWORD, :DWORD



      HCRYPTHASH equ dword
      HCRYPTPROV equ dword
      ALG_CLASS_HASH equ 32768

.data
  keyStr db "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=",0


.code
start:

LibMain proc instance:DWORD,reason:DWORD,reserved:DWORD
    ;.if reason == DLL_PROCESS_ATTACH
      mov eax,1

    ;.elseif reason == DLL_THREAD_ATTACH
      ; unused

    ;.elseif reason == DLL_THREAD_DETACH
      ; unused

    ;.elseif reason == DLL_PROCESS_DETACH
      ; unused

    ;.endif

    ret
LibMain ENDP


SendPacket PROC \
  http_ans_buffer :DWORD, \
  http_ans_buffer_len :DWORD, \
  http_host :DWORD, \
  http_data :DWORD, \
  http_service_uri :DWORD, \
  http_cookies :DWORD, \
  http_method :DWORD, \
  http_referer :DWORD, \
  http_add_headers :DWORD, \
  http_proxy_ip :DWORD, \
  http_proxy_port :DWORD, \
  http_proxy_type :DWORD, \
  http_proxy_user :DWORD, \
  http_proxy_pass :DWORD, \
  http_port :DWORD, \
  http_answer_size :DWORD

  LOCAL bConnected :BYTE
  LOCAL bAllocated :BYTE
  LOCAL socks5_allocated :BYTE
  LOCAL iSock :DWORD

  LOCAL total_length :DWORD
  LOCAL http_membuf :DWORD
  LOCAL data_len :DWORD
  LOCAL http_service_uri_len :DWORD
  LOCAL proxy_pass_len :DWORD

  LOCAL text_to_encode :DWORD

  LOCAL bytes_to_read :DWORD

  LOCAL len_buffer [12] :BYTE

  LOCAL socks5_buf :DWORD

  LOCAL http_packet_length :DWORD

  LOCAL SocketAddress :sockaddr_in


  .data
    method_post db "POST ",0
    method_get db "GET ",0

    poststr1 db " HTTP/1.0",13,10, \
                "Host: ",0
    poststr2 db 13,10, \
                "Connection: close",13,10, \
                "Content-Length: ",0

    poststr3 db 13,10,0

    poststr5 db "Content-type: application/x-www-form-urlencoded",13,10,0

    referer_str db "Referer: ",0
    cookies_str db "Cookie: ",0
    http_sym db "http://",0

    default_service_uri db "/",0

    proxy_pass db "Proxy-Authorization: Basic ",0
    proxy_sym db ":",0
    get_query_sym db  "?",0

    socks5_auth_packet db 05,02,00,02

  .code
    push esi
    push edi
    push ebx

    mov eax,http_ans_buffer
    mov byte ptr [eax],0

    mov bConnected,0
    mov bAllocated,0
    mov socks5_allocated,0

    m2m total_length,http_host

    .if http_data!=0
      mov data_len,FUNC(lstrlen,http_data)
      add total_length,eax
      inc total_length
    .endif

    .if http_service_uri!=0
      mov http_service_uri_len,FUNC(lstrlen,http_service_uri)
      add total_length,eax
    .else
      inc total_length
    .endif

    .if http_cookies!=0
      add total_length,FUNC(lstrlen,http_cookies)
      add total_length,10
    .endif

    .if http_referer!=0
      add total_length,FUNC(lstrlen,http_referer)
      add total_length,11
    .endif

    .if http_add_headers!=0
      add total_length,FUNC(lstrlen,http_add_headers)
    .endif

    add total_length,73

    .if http_method==1
      add total_length,49
    .endif

    .if http_proxy_user!=0 && http_proxy_type==0
      add total_length,29

      mov proxy_pass_len,FUNC(lstrlen,http_proxy_user)
      add proxy_pass_len,FUNC(lstrlen,http_proxy_pass)
      add proxy_pass_len,2

      mov eax,proxy_pass_len


      xor edx,edx
      mov ebx,3
      mul ebx
      xor edx,edx
      mov ebx,2
      div ebx
      add eax,5

      add total_length,eax
      mov proxy_pass_len,eax
    .endif

    .if http_proxy_ip!=0
      add total_length,13

      .if http_service_uri!=0
        mov eax,http_service_uri_len
        add total_length,eax
      .else
        inc total_length
      .endif
    .endif

    .if http_proxy_ip==0
      invoke gethostbyname,http_host
      test eax,eax
      jne @F
        mov eax,1 ;error resolving hostname
        jmp http_err
    @@:

      mov eax,[eax+12]
      mov eax,[eax]
      mov eax,[eax]
    .else
      invoke inet_addr,http_proxy_ip

      cmp eax,INADDR_NONE
      jne @F
        mov eax,7 ;error in proxy IP
        jmp http_err
    @@:

    .endif


    MOV SocketAddress.sin_addr,EAX

    .if http_proxy_port!=0
      invoke htons,http_proxy_port
    .elseif http_port==0
      invoke htons,80
    .else
      invoke htons,http_port
    .endif

    mov SocketAddress.sin_port,AX

    MOV SocketAddress.sin_family,AF_INET


    invoke VirtualAlloc,0,total_length,MEM_COMMIT,PAGE_READWRITE
    .if eax==0
      mov eax,4 ;error allocating memory
      jmp http_err
    .endif

    mov http_membuf,eax
    mov bAllocated,1


    .if http_method==0
      mov eax,offset method_get
    .else
      mov eax,offset method_post
    .endif

    invoke lstrcpy,http_membuf,eax

    .if http_proxy_ip!=0 && http_proxy_type==0
      invoke lstrcat,http_membuf,offset http_sym
      invoke lstrcat,http_membuf,http_host
      invoke lstrcat,http_membuf,offset proxy_sym

      .if http_port==0
        mov eax,80
      .else
        mov eax,http_port
      .endif

      invoke wsprintf,addr len_buffer,chr$("%u"),eax
      invoke lstrcat,http_membuf,addr len_buffer
    .endif

    .if http_service_uri==0
      mov eax,offset default_service_uri
    .else
      mov eax,http_service_uri
    .endif

    invoke lstrcat,http_membuf,eax

    .if http_method==0 && http_data!=0
      invoke lstrcat,http_membuf,offset get_query_sym
      invoke lstrcat,http_membuf,http_data
    .endif


    invoke lstrcat,http_membuf,offset poststr1
    invoke lstrcat,http_membuf,http_host
    invoke lstrcat,http_membuf,offset poststr2


    .if http_method==0 || http_data==0
      xor eax,eax
    .else
      mov eax,data_len
    .endif


    invoke wsprintf,addr len_buffer,chr$("%u"),eax
    invoke lstrcat,http_membuf,addr len_buffer
    invoke lstrcat,http_membuf,offset poststr3

    .if http_method==1
      invoke lstrcat,http_membuf,offset poststr5
    .endif

    .if http_referer!=0
      invoke lstrcat,http_membuf,offset referer_str
      invoke lstrcat,http_membuf,http_referer
      invoke lstrcat,http_membuf,offset poststr3
    .endif

    .if http_cookies!=0
      invoke lstrcat,http_membuf,offset cookies_str
      invoke lstrcat,http_membuf,http_cookies
      invoke lstrcat,http_membuf,offset poststr3
    .endif

    .if http_add_headers!=0
      invoke lstrcat,http_membuf,http_add_headers
    .endif


    .if http_proxy_user!=0 && http_proxy_type==0
      invoke lstrcat,http_membuf,offset proxy_pass

      invoke VirtualAlloc,0,proxy_pass_len,MEM_COMMIT,PAGE_READWRITE
      .if eax==0
        mov eax,4 ;error allocating memory
        jmp http_err
      .endif

      mov text_to_encode,eax
      invoke lstrcpy,text_to_encode,http_proxy_user
      invoke lstrcat,text_to_encode,offset proxy_sym
      invoke lstrcat,text_to_encode,http_proxy_pass

      invoke lstrlen,http_membuf
      add eax,http_membuf
      invoke base64_encode,text_to_encode,eax,proxy_pass_len,0

      invoke VirtualFree,text_to_encode,0,MEM_RELEASE

      invoke lstrcat,http_membuf,offset poststr3
    .endif



    invoke lstrcat,http_membuf,offset poststr3

    .if http_method==1 && http_data!=0
      invoke lstrcat,http_membuf,http_data
    .endif



    mov total_length,FUNC(lstrlen,http_membuf)

    invoke socket,AF_INET,SOCK_STREAM,IPPROTO_TCP
    CMP EAX,INVALID_SOCKET
    jne @F
      mov eax,2 ;error creating socket
      jmp http_err
  @@:

    mov iSock,eax

    invoke connect,iSock,addr SocketAddress,sizeof sockaddr_in
    test eax,eax
    je @F
      mov eax,3 ;error connecting to socket
      jmp http_err
  @@:

    mov bConnected,1



    .if http_proxy_ip!=0 && http_proxy_type==1
      invoke send,iSock,offset socks5_auth_packet,4,0
      cmp eax,4
      je @F
        mov eax,8 ;error sending socks5 authorization packet
        jmp http_err
    @@:

      invoke VirtualAlloc,0,550,MEM_COMMIT,PAGE_READWRITE
      .if eax==0
        mov eax,4 ;error allocating memory
        jmp http_err
      .endif

      mov socks5_buf,eax
      mov socks5_allocated,1

      invoke recv,iSock,eax,4,0
      cmp eax,-1
      jne @F
        mov eax,9 ;error receiving socks5 authorization packet
        jmp http_err
    @@:

      mov edi,socks5_buf
      mov ax,word ptr [edi]


      .if ax==0000001000000101b
        .if http_proxy_user==0
          mov eax,15 ;socks5 server requires authorization
          jmp http_err
        .endif

        mov ecx,FUNC(lstrlen,http_proxy_user)
        push ecx
        mov edx,FUNC(lstrlen,http_proxy_pass)
        pop ecx

        .if ecx>255
          mov ecx,255
        .endif

        .if edx>255
          mov edx,255
        .endif

        mov ebx,socks5_buf
        mov byte ptr [ebx],01
        inc ebx
        mov byte ptr [ebx],cl
        inc ebx

        push ebx
        push edx
        push ecx
        invoke lstrcpyn,ebx,http_proxy_user,255
        pop ecx
        pop edx
        pop ebx

        add ebx,ecx

        mov byte ptr [ebx],dl
        inc ebx

        invoke lstrcpyn,ebx,http_proxy_pass,255



        invoke lstrlen,socks5_buf

        push eax
        invoke send,iSock,socks5_buf,eax,0
        pop ebx
        cmp eax,ebx
        je @F
          mov eax,8 ;error sending socks5 authorization packet
          jmp http_err
      @@:


        invoke recv,iSock,socks5_buf,4,0
        cmp eax,-1
        jne @F
          mov eax,9 ;error receiving socks5 authorization packet
          jmp http_err
      @@:

        mov edi,socks5_buf
        mov ax,word ptr [edi]


        .if ah!=0
          mov eax,11 ;wrong socks5 user or password
          jmp http_err
        .endif

      .elseif ax!=0000000000000101b
        mov eax,10 ;unknown socks5 server
        jmp http_err
      .endif


      mov ecx,FUNC(lstrlen,http_host)

      .if ecx>255
        mov ecx,255
      .endif



      mov edi,socks5_buf
      mov byte ptr [edi],05
      mov byte ptr [edi+1],01
      mov byte ptr [edi+2],00
      mov byte ptr [edi+3],03

      add edi,4
      mov byte ptr [edi],cl
      inc edi
      push ecx
      invoke lstrcpyn,edi,http_host,255
      pop ecx
      add edi,ecx

      .if http_port==0
        mov eax,80
      .else
        mov eax,http_port
      .endif

      xchg al,ah
      mov word ptr [edi],ax
      add edi,2
      sub edi,socks5_buf


      invoke send,iSock,socks5_buf,edi,0
      cmp eax,edi
      je @F
        mov eax,8 ;error sending socks5 authorization packet
        jmp http_err
    @@:


      invoke recv,iSock,socks5_buf,100,0
      cmp eax,-1
      jne @F
        mov eax,9 ;error receiving socks5 authorization packet
        jmp http_err
    @@:

      mov edi,socks5_buf
      mov ax,word ptr [edi]

      .if ah!=0
        mov eax,14 ;error connecting to socks5 server
        jmp http_err
      .endif

      invoke VirtualFree,socks5_buf,0,MEM_RELEASE

      mov socks5_allocated,0

    .endif



    invoke send,iSock,http_membuf,total_length,0
    cmp eax,total_length
    je @F
      mov eax,5 ;error sending packet
      jmp http_err
  @@:


    invoke VirtualFree,http_membuf,0,MEM_RELEASE
    mov bAllocated,0



    mov edi,http_ans_buffer
    xor ecx,ecx

  sread:
    m2m bytes_to_read,http_ans_buffer_len
    sub bytes_to_read,ecx
    dec bytes_to_read

    .if bytes_to_read==0
      jmp http_end_read
    .endif

    .if bytes_to_read>128
      mov bytes_to_read,128
    .endif

    push ecx
    invoke recv,iSock,edi,bytes_to_read,0
    pop ecx

    cmp eax,-1
    jne @F
      mov eax,6 ;error reading from socket
      mov byte ptr [edi],0
      jmp http_err
  @@:

    add edi,eax
    add ecx,eax

    test eax,eax
  jne sread

  http_end_read:

  .if http_answer_size!=0
    mov eax,http_answer_size
    mov dword ptr [eax],ecx
  .endif


  mov byte ptr [edi],0

  invoke closesocket,iSock
  mov bConnected,0

  xor eax,eax
  pop ebx
  pop edi
  pop esi
ret

  http_err:

  push eax

  .if bConnected==1
    invoke closesocket,iSock
  .endif

  .if bAllocated==1
    invoke VirtualFree,http_membuf,0,MEM_RELEASE
  .endif

  .if socks5_allocated==1
    invoke VirtualFree,socks5_buf,0,MEM_RELEASE
  .endif

  pop eax

  pop ebx
  pop edi
  pop esi
ret
SendPacket ENDP


base64_encode PROC \
  string_to_encode :DWORD,  \
  result_buffer :DWORD, \
  result_buffer_length :DWORD, \
  data_length :DWORD

  LOCAL textlen :DWORD

  LOCAL chr1 :BYTE
  LOCAL chr2 :BYTE
  LOCAL chr3 :BYTE

  LOCAL enc1 :BYTE
  LOCAL enc2 :BYTE
  LOCAL enc3 :BYTE
  LOCAL enc4 :BYTE

  push edi
  push esi
  push ebx

  .if data_length==0
    invoke lstrlen,string_to_encode
    mov textlen,eax
  .else
    m2m textlen,data_length
  .endif

  mov eax,textlen
  add eax,2
  add eax,eax
  add eax,eax
  mov ecx,result_buffer_length
  sub ecx,1
  mov ebx,ecx
  add ecx,ecx
  add ecx,ebx

  mov esi,result_buffer
  mov byte ptr [esi], 0

  .if eax > ecx
    pop ebx
    pop esi
    pop edi
    mov eax,0
    ret
  .endif



  mov edx,textlen
  mov edi,string_to_encode
  mov ch,1
  mov cl,1

  again:
    mov al,byte ptr [edi]
    mov chr1,al
    inc edi
    dec edx

  test edx,edx
  jnz else1
    mov chr2,0
    mov chr3,0
    mov ch,0
    jmp endif1
  else1:
    mov bl,byte ptr [edi]
    mov chr2,bl
    inc edi
    dec edx

    test edx,edx
    jnz else2
      mov cl,0
      mov chr3,0
      jmp endif1
    else2:
      mov al,byte ptr [edi]
      mov chr3,al
      inc edi
      dec edx
  endif1:

  mov al,chr1
  shr al,2
  mov enc1,al

  mov al,chr1
  and al,3
  shl al,4
  mov bl,chr2
  shr bl,4
  or al,bl
  mov enc2,al

  mov al,chr2
  and al,15
  shl al,2
  mov bl,chr3
  shr bl,6
  or al,bl
  mov enc3,al

  mov al,chr3
  and al,63
  mov enc4,al

  test ch,ch
  jnz else3
    mov enc3,64
    mov enc4,64
    jmp endif3
  else3:
  test cl,cl
    jnz endif3
    mov enc4,64
  endif3:


  movzx eax,enc1
  add eax,offset keyStr
  mov al,byte ptr [eax]
  mov byte ptr [esi],al
  inc esi

  movzx eax,enc2
  add eax,offset keyStr
  mov al,byte ptr [eax]
  mov byte ptr [esi],al
  inc esi

  movzx eax,enc3
  add eax,offset keyStr
  mov al,byte ptr [eax]
  mov byte ptr [esi],al
  inc esi

  movzx eax,enc4
  add eax,offset keyStr
  mov al,byte ptr [eax]
  mov byte ptr [esi],al
  inc esi

  test edx,edx
  jnz again

  mov byte ptr [esi],0

  pop ebx
  pop esi
  pop edi



mov eax,result_buffer
ret
base64_encode ENDP



base64_decode PROC \
  string_to_decode :DWORD,  \
  result_buffer :DWORD, \
  result_buffer_length :DWORD

  LOCAL temp_membuf :DWORD
  LOCAL curr_len :DWORD

  LOCAL chr1 :BYTE
  LOCAL chr2 :BYTE
  LOCAL chr3 :BYTE
  LOCAL chr4 :BYTE

  LOCAL enc1 :BYTE
  LOCAL enc2 :BYTE
  LOCAL enc3 :BYTE
  LOCAL enc4 :BYTE

  push edi
  push esi
  push ebx


  invoke lstrlen,string_to_decode
  inc eax
  invoke VirtualAlloc,0,eax,MEM_COMMIT,PAGE_READWRITE

  .if eax==0
    mov eax,1
    jmp base64_err
  .endif

  mov temp_membuf,eax

  mov esi,eax
  mov edi,string_to_decode

  again2:
    mov bl,byte ptr [edi]
    test bl,bl
  jz end6

  xor eax,eax
  mov ecx,offset keyStr

  search_again:
    cmp bl,byte ptr [ecx]
    je end5

    inc ecx
    inc eax
    cmp eax,65
  je end5
  jmp search_again

  end5:
    .if eax<65
      mov byte ptr [esi],bl
      inc esi
    .endif

    inc edi
  jmp again2

  end6:

  mov byte ptr [esi],0

  mov esi,result_buffer
  mov edi,temp_membuf
  mov curr_len,0

  again3:
    mov enc1,0
    mov enc2,0
    mov enc3,0
    mov enc4,0

    mov ecx,curr_len
    add ecx,3
    .if ecx>=result_buffer_length
      jmp finish_decode
    .endif

    mov bl,byte ptr [edi]
    test bl,bl
    jz finish_read
      call base64_find
      mov enc1,al
      inc edi

    mov bl,byte ptr [edi]
    test bl,bl
    jz finish_read
      call base64_find
      mov enc2,al
      inc edi

    mov bl,byte ptr [edi]
    test bl,bl
    jz finish_read
      call base64_find
      mov enc3,al
      inc edi

    mov bl,byte ptr [edi]
    test bl,bl
    jz finish_read
      call base64_find
      mov enc4,al
      inc edi

  finish_read:
    mov al,enc1
    mov bl,enc2
    shl al,2
    shr bl,4
    or al,bl
    mov byte ptr [esi],al
    inc esi

    mov al,enc2
    mov bl,enc3
    and al,15
    shl al,4
    mov cl,bl
    shr bl,2
    or al,bl
    cmp cl,64
    je @F
      mov byte ptr [esi],al
      inc esi
    @@:

    mov al,enc3
    mov bl,enc4
    and al,3
    shl al,6
    or al,bl
    cmp bl,64
    je @F
      mov byte ptr [esi],al
      inc esi
    @@:

    mov al,byte ptr [edi]
    test al,al
  jne again3

  finish_decode:

  mov byte ptr [esi],0


  invoke VirtualFree,temp_membuf,0,MEM_RELEASE

  xor eax,eax

  pop ebx
  pop esi
  pop edi
ret

  base64_err:

  pop ebx
  pop esi
  pop edi
ret
base64_decode ENDP



base64_find PROC
  xor al,al
  mov ecx,offset keyStr

  search_again2:
    cmp bl,byte ptr [ecx]
    je end7

    inc ecx
    inc al
    cmp al,65
  je end7
  jmp search_again2
  end7:
ret
base64_find ENDP



SocketInit PROC
  LOCAL WSAStruct :WSADATA

  invoke WSAStartup,0101h,addr WSAStruct
  ret
SocketInit ENDP

SocketCleanup PROC
  call WSACleanup
  ret
SocketCleanup ENDP



urlencodeW PROC text_to_convert :DWORD, result_buffer :DWORD, result_buffer_len :DWORD
  LOCAL convert_buffer :DWORD
  LOCAL convert_buffer_len :DWORD

  push esi
  push edi
  push ebx

  invoke WideCharToMultiByte,CP_UTF8,0,text_to_convert,-1,0,0,0,0
  .if eax>0
    inc eax
    mov convert_buffer_len,eax

    invoke VirtualAlloc,0,eax,MEM_COMMIT,PAGE_READWRITE
    .if eax==0
      mov eax,1
      jmp conv_error
    .endif
  .else
    mov eax,2
    jmp conv_error
  .endif

  mov convert_buffer,eax

  invoke WideCharToMultiByte,CP_UTF8,0,text_to_convert,-1,convert_buffer,convert_buffer_len,0,0

  .if eax==0
    invoke VirtualFree,convert_buffer,0,MEM_RELEASE
    mov eax,3
    jmp conv_error
  .endif

  invoke urlencode,convert_buffer,result_buffer,result_buffer_len

  invoke VirtualFree,convert_buffer,0,MEM_RELEASE

  xor eax,eax
  pop ebx
  pop edi
  pop esi
ret

conv_error:
  pop ebx
  pop edi
  pop esi
ret
urlencodeW ENDP




urlencode PROC text_to_convert :DWORD, result_buffer :DWORD, result_buffer_len :DWORD
  push esi
  push edi
  push ebx

  mov esi,result_buffer
  mov edi,text_to_convert


  loop_enc:
    mov eax,esi
    sub eax,result_buffer
    mov ebx,result_buffer_len
    sub ebx,4

    .if eax>=ebx
      jmp loop_enc_end
    .endif

    mov al,byte ptr [edi]

  .if al<80h
    .if al==' '
      mov byte ptr [esi],'+'
      inc esi
    .elseif ((al>0 && al<=47) || (al>=58 && al<=64) || (al>=91 && al<=96) || al>=123) && al!='.' && al!='_' && al!='-'
      movzx eax,al
      invoke wsprintf,esi,chr$("%%%02X"),eax
      add esi,3
    .else
      mov byte ptr [esi],al
      inc esi
    .endif
  .else
      movzx eax,al
      invoke wsprintf,esi,chr$("%%%02X"),eax
      add esi,3
  .endif

    inc edi
    mov bl,byte ptr [edi]
    test bl,bl
  jne loop_enc

loop_enc_end:

  mov byte ptr [esi],0
  pop ebx
  pop edi
  pop esi
ret
urlencode ENDP


GetHttpHeader PROC content :DWORD, result_buffer :DWORD, result_buffer_len :DWORD
  push esi
  push edi
  push ebx

  invoke InString,1,content,chr$(13,10,13,10)
  .if eax==0 || eax==-1 || eax==-2
    mov eax,result_buffer
    mov byte ptr [eax],0
  .else
    .if result_buffer_len<=eax
      mov eax,result_buffer_len
      dec eax
    .endif

    invoke lstrcpyn,result_buffer,content,eax
  .endif

  pop ebx
  pop edi
  pop esi
ret
GetHttpHeader ENDP

GetHttpBody PROC content :DWORD, result_buffer :DWORD, result_buffer_len :DWORD
  push esi
  push edi
  push ebx

  invoke InString,1,content,chr$(13,10,13,10)
  .if eax==0 || eax==-1 || eax==-2
    mov eax,result_buffer
    mov byte ptr [eax],0
  .else
    mov edi,content
    add edi,eax
    add edi,3

    invoke lstrlen,edi
    inc eax

    .if result_buffer_len<=eax
      mov eax,result_buffer_len
      dec eax
    .endif

    invoke lstrcpyn,result_buffer,edi,eax
  .endif

  pop ebx
  pop edi
  pop esi
ret
GetHttpBody ENDP


GetHttpBodyEx PROC content :DWORD, content_length :DWORD, result_buffer :DWORD, result_buffer_len :DWORD
  push esi
  push edi
  push ebx

  invoke InString,1,content,chr$(13,10,13,10)
  .if eax==0 || eax==-1 || eax==-2
    mov eax,result_buffer
    mov byte ptr [eax],0
  .else
    mov esi,content
    add eax,3
    add esi,eax

    mov ebx,content_length
    mov edi,result_buffer

    .if eax>=content_length
      mov byte ptr [edi],0
      jmp end_func
    .endif

    sub ebx,eax
    .if ebx>result_buffer_len
      mov ecx,result_buffer_len
    .else
      mov ecx,ebx
    .endif

    mov eax,ecx

    .if ecx==0
      mov byte ptr [edi],0
      jmp end_func
    .endif

    push ecx
    rep movsb
    pop ecx

    mov byte ptr [edi+ecx],0
  .endif


end_func:
  pop ebx
  pop edi
  pop esi
ret
GetHttpBodyEx ENDP


GetCookies PROC headers :DWORD, result_buffer :DWORD, result_buffer_len :DWORD
  LOCAL curr_len :DWORD
  LOCAL total_len :DWORD
  LOCAL added_syms :BYTE

  .data
    cookie_sym db 13,0

  .code

  push esi
  push edi
  push ebx

  mov eax,result_buffer
  mov byte ptr [eax],0
  mov curr_len,0

  mov total_len,FUNC(lstrlen,headers)
  mov ebx,headers
  add total_len,ebx


  mov edi,headers
  mov esi,result_buffer


  next_parse_cookies:

  invoke InString,1,edi,chr$(13,10,"Set-Cookie: ")

  .if eax!=0 && eax!=-1 && eax!=-2
    add edi,eax
    add edi,12

    invoke InString,1,edi,chr$(";")
    .if eax!=0 && eax!=-1 && eax!=-2
      mov ebx,eax
      invoke InString,1,edi,offset cookie_sym
      .if eax>=ebx || eax==0 || eax==-1 || eax==-2
        mov eax,ebx
      .endif

      add curr_len,eax
      mov ecx,curr_len
      inc ecx

      .if ecx>=result_buffer_len
        jmp end_parse_cookies
      .endif

      push eax
      invoke lstrcpyn,esi,edi,eax
      pop eax

      add esi,eax
    .else
      invoke InString,1,edi,offset cookie_sym
      .if eax!=0 && eax!=-1 && eax!=-2
        add curr_len,eax
        mov ecx,curr_len
        inc ecx

        .if ecx>=result_buffer_len
          jmp end_parse_cookies
        .endif

        push eax
        invoke lstrcpyn,esi,edi,eax
        pop eax

        add esi,eax
      .else
        invoke lstrlen,edi

        add curr_len,eax
        mov ecx,curr_len

        .if ecx>=result_buffer_len
          jmp end_parse_cookies
        .endif

        invoke lstrcpy,esi,edi

        mov added_syms,0

        jmp end_parse_cookies
      .endif
    .endif

    dec esi

    mov word ptr [esi],' ;'
    add esi,2

    add curr_len,1

    mov added_syms,1

    .if edi<total_len
      jmp next_parse_cookies
    .endif
  .endif

  end_parse_cookies:

  .if added_syms==1
    mov byte ptr [esi-2],0
  .endif

  pop ebx
  pop edi
  pop esi
ret
GetCookies ENDP

GetHTTPAnswer PROC content :DWORD
  LOCAL ans_str [5] :BYTE

  mov eax,content
  add eax,9

  invoke lstrcpyn,addr ans_str,eax,4
  invoke atodw,addr ans_str
ret
GetHTTPAnswer ENDP


MD5 PROC string :DWORD, result_buffer :DWORD
  LOCAL hHash :DWORD
  LOCAL hProv :DWORD
  LOCAL hash_size :DWORD
  LOCAL textlen :DWORD
  LOCAL dwSize :DWORD

  LOCAL hash [40] :BYTE


  push edi
  push esi
  push ebx

  mov dwSize,4

  mov textlen,FUNC(lstrlen,string)
  invoke CryptAcquireContext,addr hProv, NULL, NULL, PROV_RSA_FULL, 0
  .if eax==0
    invoke CryptAcquireContext,addr hProv, NULL, NULL, PROV_RSA_FULL, CRYPT_NEWKEYSET
    .if eax==0
      mov eax,1 ;Acquiring crypt context failed
      jmp md5_error
    .endif
  .endif

  invoke CryptCreateHash,hProv,CALG_MD5,0,0,addr hHash
  .if eax==0
    mov eax,2 ;Creating MD5 hash failed
    jmp md5_error
  .endif

  invoke CryptHashData,hHash,string,textlen,0
  .if eax==0
    mov eax,3 ;Hashing failed
    jmp md5_error
  .endif

  invoke CryptGetHashParam,hHash,HP_HASHSIZE,addr hash_size,addr dwSize,0
  .if eax==0
    mov eax,4 ;Couldnot get hash parameter
    jmp md5_error
  .endif

  invoke CryptGetHashParam,hHash,HP_HASHVAL,addr hash,addr hash_size,0
  .if eax==0
    mov eax,4 ;Couldnot get hash parameter
    jmp md5_error
  .endif


  invoke CryptDestroyHash,hHash
  invoke CryptReleaseContext,hProv,0

  mov esi,result_buffer
  lea edi,hash

    mov ecx,0
  hash_get:
    push ecx
    movzx eax,byte ptr [edi]
    invoke wsprintf,esi,chr$("%2.2x"),eax

    inc edi
    add esi,2

    pop ecx
    inc ecx
    cmp ecx,hash_size
  jne hash_get

  mov byte ptr [esi],0

  xor eax,eax
  pop ebx
  pop esi
  pop edi
ret

  md5_error:

  pop ebx
  pop esi
  pop edi
ret
MD5 ENDP


end LibMain